
//********************************************************************
//
//	NOMBRE DEL ARCHIVO:   	cola.cpp
//	MDULO:			
//	FECHA:			
//	AUTOR:                  Arturo Gil Aparicio
//	DESCRIPCIN:            Implementacin de la clase CCola
//
//********************************************************************

#define  __COLA_CPP__

// Libreras Estndar
#include <iostream.h>
// Otras libreras

// Encabezado Mdulo-Proyecto

// Encabezado del archivo
#include "..\inc\cola.h"


// Variables Globales externas

// Variables Globales internas


//********************************************************************
//	Nombre Funcin: CONSTRUCTORES
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************
CCola::CCola(void) //constructor por defecto
{
       pTopeCola = NULL;
       pFondoCola = NULL;       
}

CCola::CCola(const CCola &cola_orig) //constructor copia
{
     nodoCola *aux;
         
     aux = cola_orig.pTopeCola;
     while(aux != NULL)
     {
               InsertarElemento(aux->cadena); 
               aux = aux->sig; 
     }     
}

CCola::~CCola(void) 
{                   
     while(pTopeCola != NULL)  //recorremos toda la cola
              ExtraerElemento();
}
     
//********************************************************************
//	Nombre Funcin: METODOS
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************    
int CCola::InsertarElemento(char* cade)
{
    nodoCola *pel; 
    
    pel = new nodoCola;
    if(pel == NULL) 
           return(-1);           
    
    if(pFondoCola != NULL) 
        pFondoCola->sig = pel; 
    
    else
       pTopeCola = pel;

    strcpy(pel->cadena, cade);     
  
    pFondoCola = pel;
    pFondoCola->sig = NULL;   
    
    return(0); 
}
 
char* CCola::ExtraerElemento(void)
{
    nodoCola *aux;
    char temp[MAX];

    if(pTopeCola == NULL) //cola vaca
        cout << "\nLa cola esta vacia.\n\n";         
         
    else
    {   
        aux = pTopeCola;        
        pTopeCola = pTopeCola->sig; 
                                    
        if(pTopeCola == NULL)
                pFondoCola = NULL; 

        strcpy(temp, aux->cadena);
        delete(aux);
    }

 return  temp; 
}

void CCola::MostrarCola(void) const
{
     nodoCola *aux;
     
     if(pTopeCola == NULL)
                  cout << "\nLa cola esta vacia.\n\n";
     else
     {   aux = pTopeCola;
         while(aux != NULL)
         {         cout << "Cadena: " << aux->cadena << "\n";
                   aux = aux->sig; //apuntamos al siguiente de la lista
                   cout << "\n";                   
                   }
         }
     
 }
 
 int CCola::ContarElementos(void) const
{
   nodoCola *aux;
   int cont=0; 
   
   if(pTopeCola == NULL)
      return(0);
      
   else
   {  
      aux = pTopeCola;
      while(aux != NULL)
       {      cont++;
              aux=aux->sig;
       }        
   }
   return cont;
}

int CCola::ColaVacia(void) const
{
    if(pTopeCola == NULL)
        return(1);
    
    else
        return(0);
}

//********************************************************************
//	Nombre Funcin: SOBRECARGA DE OPERADORES
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************    
CCola& CCola::operator = (const CCola &cola_orig) 
{
       nodoCola *aux;
       
       while(pTopeCola != NULL)  //recorremos toda la cola
              ExtraerElemento(); //liberamos elementos existentes
              
       aux = cola_orig.pTopeCola;
       while(aux != NULL)
       {
               InsertarElemento(aux->cadena); 
               aux = aux->sig; 
       }
       return(*this); 
}

CCola CCola::operator + (const CCola &cola_orig)
{
      CCola temp(*this); //copiamos la cola actual en cola auxiliar temp
      nodoCola *aux;
            
      aux = cola_orig.pTopeCola;
      while(aux != NULL)
      {
             temp.InsertarElemento(aux->cadena); 
             aux = aux->sig;
      }
      return(temp);                         
}
