//********************************************************************
//
//	NOMBRE DEL ARCHIVO:   	conjunto.cpp
//	MDULO:			
//	FECHA:			
//	AUTOR:                  Arturo Gil Aparicio
//	DESCRIPCIN:
//
//********************************************************************

#define  __CONJUNTO_CPP__

// Libreras Estndar
#include <iostream.h>
// Otras libreras

// Encabezado Mdulo-Proyecto

// Encabezado del archivo
#include "..\inc\conjunto.h"

// Variables Globales externas

// Variables Globales internas

//********************************************************************
//	Nombre Funcin: CONSTRUCTORES
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************
CConjunto::CConjunto(void) //constructor por defecto
{
}

CConjunto::CConjunto(const CConjunto &cjto_orig) //constructor copia
{
     datos = cjto_orig.datos;     
}

CConjunto::~CConjunto(void) //destructor
{
    
}
     
//********************************************************************
//	Nombre Funcin: METODOS
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************    
int CConjunto::IntroducirElemento(char* cade)
{
    int n, i; 
    char ca[MAX];
    
    n = datos.ContarElementos();
    
    //Comprobamos que no existe ya la cadena
    for(i=0; i < n; i++)
    {
             // Extraemos una cadena de la cola
             strcpy(ca, datos.ExtraerElemento());
             
             //Comprobamos si coincide con la cadena
             // a introducir
             if(strcmp(ca, cade)== 0)
             {
                    datos.InsertarElemento(ca);   
                    return 0;
             } 
             // Si la cadena no es igual la volvemos a 
             // meter en la cola y seguimos buscando
             datos.InsertarElemento(ca);   
    }
    //No se ha encontrado el elemento.
    // lo insertamos
    datos.InsertarElemento(cade);      

    return 1;
}
 
int CConjunto::EliminarElemento(char * cade)
{
    int n; //numero de elementos en la cola
    int i;
    char ca[MAX];
    
    n = datos.ContarElementos();
    
    //Comprobamos que no existe ya la cadena
    for(i=0; i < n; i++)
    {
             strcpy(ca, datos.ExtraerElemento());

             //Se elimina el elemento             
             if(strcmp(ca, cade)==0)
                           return 1;
                         
             datos.InsertarElemento(ca);   
    } 
    
    return 0; 
}

void CConjunto::MostrarDatos()
{
        datos.MostrarCola();       
}

//********************************************************************
//	Nombre Funcin: OPERADORES
//	Variables globales:
//	Variables de salida:
// 	Comentarios (parmetros):
//
//********************************************************************
//Asignacin
CConjunto& CConjunto::operator = (const CConjunto &cjto_orig) //constructor copia, pero borrando lo que habia previamente
{
       datos = cjto_orig.datos;    
}

//Unin
CConjunto CConjunto::operator + (const CConjunto &cjto_orig)
{
      CConjunto temp(cjto_orig); //copiamos la cola actual en cola auxiliar temp
      CConjunto temp2(*this);
      int n;
      char cad[MAX];
      
      n = temp.datos.ContarElementos();
      
      for(int i = 0; i < n; i++)
      {      
             strcpy(cad, temp.datos.ExtraerElemento());
             temp2.IntroducirElemento(cad);        
      }
              
      return temp2;                                           
}

//Diferencia
CConjunto CConjunto::operator - (const CConjunto &cjto_orig)
{
      CConjunto temp(cjto_orig); //copiamos la cola actual en cola auxiliar temp
      CConjunto temp2(*this);
      int n;
      char cad[MAX];
      
      n = temp.datos.ContarElementos();
      
      for(int i = 0; i < n; i++)
      {      
             strcpy(cad, temp.datos.ExtraerElemento());
             temp2.EliminarElemento(cad);
      }
              
      return temp2;                                           
}

//Interseccin
CConjunto CConjunto::operator * (const CConjunto &cjto_orig)
{
      CConjunto temp(cjto_orig); //copiamos la cola actual en cola auxiliar temp
      CConjunto temp2(*this);
      CConjunto inter;
      
      int n, a;
      char cad[MAX];
      
      n = temp.datos.ContarElementos();
      
      for(int i = 0; i < n; i++)
      {      
             strcpy(cad, temp.datos.ExtraerElemento());
             a = temp2.IntroducirElemento(cad);
             
             if(!a)
                  inter.IntroducirElemento(cad);             
      }
              
      return inter;                                           
}
